<?php
/*
	Plugin Name: Post Ideas
	Plugin URI: http://www.aaronrobbins.com/042008/manage-your-blog-post-ideas-with-this-wordpress-plugin
	Description: Keep track of all your great article or post ideas. Activate plugin and then choose Manage > Post Ideas.
	Author: Aaron Robbins
	Version: 2
	Author URI: http://www.aaronrobbins.com
*/
/*
Wordpress Plug-in Post Ideas
Copyright (C) 2008 Aaron Robbins  (aaron AT aaronrobbins DOT com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
    * Install BTPI Table
    *
*/
function btpi_install(){
    //Set db version
    $btpi_db_version = "1.0";
    //Get database info
    global $wpdb;
    //Set new table name
    $table_name = $wpdb->prefix . "btpi";
    //Check for existing table name
    if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
        //Table name available
        //Setup table parameters
        $sql = "CREATE TABLE " . $table_name . " (
	            id mediumint(9) NOT NULL AUTO_INCREMENT,
	            time bigint(11) DEFAULT '0' NOT NULL,
	            title text NOT NULL,
	            description text NOT NULL,
                keywords text NOT NULL,
	            urls text NOT NULL,
                priority smallint(2) DEFAULT '1' NOT NULL,
                PRIMARY KEY  (id)
	        );";
        //Create Table
        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
        dbDelta($sql);
        echo "Table created.";
        //Setup example entry
        $example_title = "5 Reasons to use Post Ideas";
        $example_description = "This will be a short article on why Post Ideas is a neat-o plugin.";
        $example_keywords = "Wordpress plugins,post ideas,article idea manager";
        $example_urls = "http://www.blogheap.com";
        $example_priority = 1;
        //Insert example entry
        $insert = "INSERT INTO " . $table_name .
            " (time, title, description, keywords, urls, priority) " .
            "VALUES ('" . time() . "','" . $wpdb->escape($example_title) . "','" . $wpdb->escape($example_description) . "','" . $wpdb->escape($example_keywords) . "','" . $wpdb->escape($example_urls) . "','" . $wpdb->escape($example_priority) . "')";
        //Run insert
        $results = $wpdb->query( $insert );
        //Add version option
        add_option("btpi_db_version", $btpi_db_version);

    }
    else{
        //Table name unavailable
        $table_name . " does exist.";
    }
}

/**
    * Create Manage Page
    *
*/
function postideas_admin() {
	if ( function_exists('add_management_page') ) {
		add_management_page('Post Ideas Options', 'Post Ideas', 8, basename(__FILE__), 'postideas_admin_form');
	}
}
/**
    * Post Idea Form
**/
function postideas_admin_form() {
    global $wpdb;
    //Set table name
    $table_name = $wpdb->prefix . "btpi";

    // Process form submissions
	if (isset($_POST['submit_Add']) || isset($_POST['submit_Edit'])) {
        //Level Check
	    if (function_exists('current_user_can') && !current_user_can('manage_options') )
	    die(__('Error. This user is not allowed to manage options.'));
        //Referer check
        check_admin_referer('btpi_postidea_add');
            //Set variables
            $title =  $_POST['btpi_addIdeaTitle'];
            $description = $_POST['btpi_addIdeaDescription'];
            $keywords = $_POST['btpi_addIdeaKeywords'];
            $urls = $_POST['btpi_addIdeaURLS'];
            $priority = $_POST['btpi_addIdeaPriority'];
            if (isset($_POST['submit_Add'])){
                //Setup Insert
                $insert = "INSERT INTO " . $table_name .
                " (time, title, description, keywords, urls, priority) " .
                "VALUES ('" . time() . "','" . $wpdb->escape($title) . "','" . $wpdb->escape($description) . "','" . $wpdb->escape($keywords) . "','" . $wpdb->escape($urls) . "','" . $wpdb->escape($priority) . "')";
                //Run insert
                $results = $wpdb->query( $insert );
                $update_fade = '<div id="message" class="updated fade"><p>Your post idea was added.</p></div>';
            }
            else{
                $editid = $_POST['btpi_editid'];
                //Setup Update
                $update = "UPDATE " . $table_name . " SET title='" . $wpdb->escape($title) . "', description='" . $wpdb->escape($description) . "', keywords='" . $wpdb->escape($keywords) . "', urls='" . $wpdb->escape($urls) . "', priority='" . $wpdb->escape($priority) ."' WHERE id=$editid";
                //Run insert
                $results = $wpdb->query( $update );
                $update_fade = '<div id="message" class="updated fade"><p>Your post idea was updated.</p></div>';
            }
    }
    else{
    }

    //Process Delete
    if($_GET['delete']){
        //Level check
        if (function_exists('current_user_can') && !current_user_can('manage_options') )
	    die(__('Error. This user is not allowed to manage options.'));
        //Get var
        $postid = $_GET['delete'];
        $posttitle = $_GET['title'];
        $posttitle = htmlentities(stripslashes($posttitle));
        //Make confirmation
        $update_fade = '<div id="message" class="updated fade"><p>Really delete post idea  "'.$posttitle.'"? <a href="?page=postideas.php&amp;deleteconfirmed='.$postid.'">Yes</a> | <a href="?page=postideas.php">No</a></p></div>';
    }
    else if($_GET['deleteconfirmed']){
        if (function_exists('current_user_can') && !current_user_can('manage_options') )
	    die(__('Error. This user is not allowed to manage options.'));
        $postid = $_GET['deleteconfirmed'];
        //Setup delete
        $delete =  "DELETE FROM $table_name WHERE id=$postid";
        //Do delete
        $results = $wpdb->query( $delete );
        if($_GET['writeconfirmed'] && $_GET['writetitle']){
            $title = $_GET['writetitle'];
            //Make confirmation
            $update_fade = "<div id=\"message\" class=\"updated fade\"><p>Post Idea deleted. &nbsp; &raquo; &raquo; <a href=\"post-new.php?post_title=$title\">Begin Writing</a></p></div>";
        }
        else{
            //Make confirmation
            $update_fade = '<div id="message" class="updated fade"><p>Post Idea deleted.</p></div>';
        }

    }
    else{
    }

    //Process Write
    if($_GET['write']){
        //Level check
        if (function_exists('current_user_can') && !current_user_can('manage_options') )
	    die(__('Error. This user is not allowed to manage options.'));
        //Get var
        $postid = $_GET['write'];
        $posttitle = $_GET['title'];
        $posttitle = htmlentities(stripslashes($posttitle));
        //Make confirmation
        $update_fade = '<div id="message" class="updated fade"><p>Writing "'.$posttitle.'" will delete it from the Post Ideas list. <a href="?page=postideas.php&amp;deleteconfirmed='.$postid.'&amp;writeconfirmed=yes&amp;writetitle='.$posttitle.'">Continue</a> | <a href="?page=postideas.php">Cancel</a></p></div>';
    }
    else{
    }

    //Get Post Ideas
    //Check for order by
    if($_GET['orderby'] == "newest"){
        $orderby = "ORDER BY time DESC";
        $orderby_newest_marker = "&raquo; ";
    }
    else if($_GET['orderby'] == "oldest"){
        $orderby = "ORDER BY time ASC";
        $orderby_oldest_marker = "&raquo; ";
    }
    else if($_GET['orderby'] == "title"){
        $orderby = "ORDER BY title ASC";
        $orderby_title_marker = "&raquo; ";
    }
    else if($_GET['orderby'] == "priority"){
        $orderby = "ORDER BY priority ASC";
        $orderby_priority_marker = "&raquo; ";
    }
    else{
        $orderby = "ORDER BY time DESC";
        $orderby_newest_marker = "&raquo; ";
    }
    //Start output
    $output = "";
    $postideas = $wpdb->get_results("SELECT * FROM $table_name $orderby");
    //Loop through results
    foreach ($postideas as $postidea) {
        if($_GET['edit'] && $postidea->id == $_GET['edit']){
            $edit_id = $postidea->id;
            $edit_title = htmlentities(stripslashes($postidea->title));
            $edit_description = htmlentities(stripslashes($postidea->description));
            $edit_keywords = htmlentities(stripslashes($postidea->keywords));
            $edit_urls = htmlentities(stripslashes($postidea->urls));
            $edit_priority = $postidea->priority;
        }
        else{
        }
        $links = explode("|",$postidea->urls);
        $link_list = "";
        $link_i = 1;
        foreach($links as $link){
            $link_list .= "$link_i. <a href=\"$link\">$link</a>&nbsp; ";
            $link_i++;
        }
        $output .= "<ul style=\"list-style:none; margin-bottom:.5em; border:1px solid #ddd; padding:.5em;\">";
	    $output .= "<li style=\"padding-bottom:1px;\"><strong style=\"color:#999;\">Working Title:</strong><span style=\"font-size:17px;\"> ".stripslashes($postidea->title)."</span></li>";
        $output .= "<li style=\"padding-bottom:1px;\"><strong style=\"color:#999;\">Description:</strong> ".stripslashes($postidea->description)."</li>";
        $output .= "<li style=\"padding-bottom:1px;\"><strong style=\"color:#999;\">Keywords:</strong> ".stripslashes($postidea->keywords)."</li>";
        $output .= "<li style=\"padding-bottom:1px; margin-bottom:15px;\"><strong style=\"color:#999;\">Links:</strong> ".$link_list."</li>";
        $output .= "<li style=\"background:#FBF2FF; padding:4px;\"><a href=\"".$_SERVER['PHP_SELF']."?page=postideas.php&amp;write=".$postidea->id."&amp;title=".htmlentities(stripslashes($postidea->title))."\">Write This</a> | <a href=\"".$_SERVER['PHP_SELF']."?page=postideas.php&amp;edit=".$postidea->id."&amp;title=".$postidea->title."\">Edit</a> | <a href=\"".$_SERVER['PHP_SELF']."?page=postideas.php&amp;delete=".$postidea->id."&amp;title=".htmlentities(stripslashes($postidea->title))."\">Delete</a>&nbsp; <em>(Priority: ".$postidea->priority.")</em></li>";
        $output .= "</ul>";
    }
    //Setup add or edit
    if($_GET['edit']){
        $form_word = "Edit";
        $switch = "<a href=\"".$_SERVER['PHP_SELF']."?page=postideas.php\">Add</a>";
    }
    else{
        $form_word = "Add";
    }

?>
<?php echo $update_fade; ?>
<div class=wrap>
	<h2><?php echo $form_word; ?> Post Ideas</h2>
	<form name="btpi_postideas" method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>?page=postideas.php&amp;updated=true">
		<input type="hidden" name="btpi_postidea_add" value="1" /> <?php if ( function_exists('wp_nonce_field') ) wp_nonce_field('btpi_postidea_add'); ?>
        <input type="hidden" name="btpi_editid" value="<?php echo $edit_id; ?>" />
		<fieldset>
			<table align="left" cellpadding="5" cellspacing="5">
				<tr>
					<td align="right" valign="top">Working Title: </td><td colspan="2" align="left" valign="top"><input name="btpi_addIdeaTitle" type="text" id="btpi_addIdeaTitle" value="<?php echo $edit_title; ?>" size="60" /></td>
				</tr>
                <tr>
					<td align="right" valign="top">Description: </td><td colspan="2" align="left" valign="top"><input name="btpi_addIdeaDescription" type="text" id="btpi_addIdeaDescription" value="<?php echo $edit_description; ?>" size="60" /></td>
				</tr>
                <tr>
					<td align="right" valign="top">Target Keywords: </td><td colspan="2" align="left" valign="top"><input name="btpi_addIdeaKeywords" type="text" id="btpi_addIdeaKeywords" value="<?php echo $edit_keywords; ?>" size="60" /></td>
				</tr>
                <tr>
					<td align="right" valign="top">Links ( | seperated ): </td><td colspan="2" align="left" valign="top"><textarea name="btpi_addIdeaURLS" id="btpi_addIdeaURLS" rows="2" cols="58"><?php echo $edit_urls; ?></textarea></td>
				</tr>
                <tr>
					<td align="right" valign="top">Priority (1-99):</td><td align="left" valign="top"><input name="btpi_addIdeaPriority" type="text" id="btpi_addIdeaPriority" value="<?php echo $edit_priority; ?>" size="3" maxlength="2" /></td><td align="left" valign="top"><div class="submit"><?php echo $switch; ?>&nbsp; <input type="submit" name="submit_<?php echo $form_word; ?>" value="<?php echo $form_word; ?> Post Idea &raquo;" /></div> </td>
				</tr>
			</table>
		</fieldset>
	</form>
    <h2>Post Ideas</h2>
    <table>
        <tr>
            <td>Order by: <?php echo $orderby_newest_marker; ?><a href="<?php echo $_SERVER['PHP_SELF']; ?>?page=postideas.php&amp;orderby=newest">Newest</a> &nbsp;&nbsp; <?php echo $orderby_oldest_marker; ?><a href="<?php echo $_SERVER['PHP_SELF']; ?>?page=postideas.php&amp;orderby=oldest">Oldest</a> &nbsp;&nbsp; <?php echo $orderby_title_marker; ?><a href="<?php echo $_SERVER['PHP_SELF']; ?>?page=postideas.php&amp;orderby=title">Title</a> &nbsp;&nbsp; <?php echo $orderby_priority_marker; ?><a href="<?php echo $_SERVER['PHP_SELF']; ?>?page=postideas.php&amp;orderby=priority">Priority</a></td>
        </tr>
    </table>
    <?php echo $output; ?>
</div>

<?php
}

/**
    * Hooks
**/
//Install
register_activation_hook(__FILE__,'btpi_install');
//Manage Menu
add_action('admin_menu', 'postideas_admin');
?>